// twitter.js

var Twippera = {
    version : '20070714-1',
    release : 20,
    TID     : null,
    XHRID   : null,
    user    : "",
    pass    : "",
    time    : "",
    locale  : "en",
    count   : 140,
    postMsgs : [],
    PMindx  : 0,
    cache   : [],
    timeout : 30000,
    loadSetting : function() {
        widget.setPreferenceForKey('front', 'state');
        widget.setPreferenceForKey('show', 'list');
        this.locale = widget.preferenceForKey("locale") || "en";
        $('locale').selectedIndex = localeIndex[this.locale];
        this.setLocale(this.locale);
        this.user = widget.preferenceForKey('user');
        this.pass = widget.preferenceForKey('pass');
        this.time = widget.preferenceForKey('time');
        this.ear  = widget.preferenceForKey('enableReflesh');
        this.timeout = parseInt(widget.preferenceForKey('timeout'))

        $('count').innerHTML = this.count;
        document.getElementsByTagName('title')[0].innerHTML += '[' + this.user + ']'

        if(this.user != "" && this.pass !="") {
            $('user').value = this.user;
            $('pass').value = this.pass;
            if(this.ear == "true") {
                $("sar").checked = true;
                $("reflesh").value = this.time / 60000; 
                this.autoReflesh(this.time);
            } else {
                $("sar").checked = false;
                this.update('friends_timeline');
            }
            $('timeout').value = this.timeout / 1000;
        } else {
            this.flipWidget("back");
        }
    },
    initSetting : function() {
        var user = $('user').value;
        var pass = $('pass').value
        //save user & pass
        widget.setPreferenceForKey(user, 'user');
        widget.setPreferenceForKey(pass, 'pass');

        if($('sar').checked) {
            var time = parseInt($('reflesh').value) * 1000 * 60;
            //save auto reflesh setting
            widget.setPreferenceForKey("true", "enableReflesh");
            widget.setPreferenceForKey(time, "time");
        } else {
            widget.setPreferenceForKey("false", "enableReflesh");
            clearTimeout(this.TID);
        }
        var timeout = parseInt($('timeout').value) * 1000;
        widget.setPreferenceForKey(timeout, 'timeout');

// Set Locale
        var localeSel = $("locale");
        var locale = localeSel.options[localeSel.selectedIndex].value;
        widget.setPreferenceForKey(locale, "locale");

        this.loadSetting();
        this.flipWidget('front');
    },
    setLocale : function(lng) {
        var lang = Langs[lng];
        for(var i in lang) {
            $(i) .innerHTML = lang[i];
        }
        if(lng == "ja") {
            $('save').style.backgroundImage = 'url("images/save_ja.png")'
        } else if(lng == "es") {
            $('save').style.backgroundImage = 'url("images/save_es.png")'
        } else {
            $('save').style.backgroundImage = 'url("images/save.png")'
        }
    },
    initEvent : function() {
        var self = this;
        $('header').addEventListener('dblclick', function() {
            self.foldMsgList();
        }, false);
        $('reload').addEventListener('click', function(){
            if(self.ear == 'true') {
                self.autoReflesh();
            } else {
                self.update("friends_timeline");
            }
        }, false);
        $('pref').addEventListener('click', function() {
            if(widget.preferenceForKey('state') == 'front') {
                self.flipWidget('back');
            } else {
                self.flipWidget('front');
            }
        }, false);
        $('close').addEventListener('click', function() {
            window.close();
        }, false);

        $('status').addEventListener('keyup', function(evt) {
            self.watchKeyEvent(evt.keyCode);
        }, false);

        $('post').addEventListener('click', function() {
            self.update('update');
        }, false);

        $('save').addEventListener('click', function() {
            self.initSetting();
        }, false);

        $('about').addEventListener('click', function() {
            self.showPopup(
                '<h2>'+SPLangs.about[self.locale]+'</h2><p><span>' +
                SPLangs.version[self.locale] +
                '</span>: ' + 
                self.version +
                ' (<a href="http://widgets.opera.com/widget/6522">' +
                SPLangs.download[self.locale] +
                '</a>)</p><p>' +
                SPLangs.author[self.locale] +
                ': <a href="http://higeorange.com/">Higeorange</a> (<a href="http://twitter.com/higeorange">Twitter</a>)</p><p>' +
                SPLangs.design[self.locale] +
                ': tobetchi (<a href="http://twitter.com/tobetchi">Twitter</a>)</p><p>' +
                SPLangs.estrans[self.locale] +
                ': Eduardo Escárez</p>',
                SPLangs.close[self.locale],
                function() {
                }
            )
        }, false);

        $('pclose').addEventListener('click', function() {
            self.hidePopup();
        }, false);

    },
    // 文字数カウント
    // Post History 未実装
    watchKeyEvent : function(key) {
        switch(key) {
            case 38:
                if(this.postMsgs[this.PMindx + 1]) {
                    this.showPostHistory('back');
                }
                break;
            case 40:
                if(this.postMsgs[this.PMindx - 1]) {
                    this.showPostHistory('forward');
                }
                break;
            default:
                var status = $('status').value
                var rest   = this.count - status.length;
                $('count').innerHTML = (rest >= 0) ? rest : 0;
                break;
        }
    },
    showPostHistory : function(to) {
        var status = $('status')
        if(to == 'back') {
            if(this.PMindx == 0) {
                this.postMsgs[0] = { msg: $('status').value, post: 0};
            }
            this.PMindx += 1;
        } else if (to == 'forward') {
            this.PMindx -= 1;
        }
        status.value = this.postMsgs[this.PMindx].msg;
        setCaretPosition(status, status.value.length);
    },
    // from my.opera sample widget
    // 設定画面 / メイン画面
    flipWidget : function(to) {
        switch (to) {
            case "back":
                $('front').style.display  = "none";
                $('config').style.display = "block";
                widget.setPreferenceForKey('back', 'state');
                break;
            case "front":
                $('front').style.display  = "block";
                $('config').style.display = "none";
                widget.setPreferenceForKey('front', 'state');
                break;
            default:
                break;
        }
    },
    // メッセージ折り畳み
    foldMsgList : function() {
        switch (widget.preferenceForKey('list')) {
            case "show":
                $('updateList').style.height = '0'
                widget.setPreferenceForKey('hide', 'list');
                break;
            case "hide":
                $('updateList').style.height = '280px'
                widget.setPreferenceForKey('show', 'list');
                break;
            default:
                break;
        }
    },
    autoReflesh : function() {
        clearTimeout(this.TID);
        var self = this;
        this.update("friends_timeline");
        this.TID = setTimeout(function(){ self.autoReflesh() }, self.time);
    },
    // ポスト, ステータス取得
    update : function(type) {
        var self = this;
            self.hidePopup();
        var status = ""
        if(type == 'update') {
            status = $('status').value;
            if(status == "") return;
            $('status').value = "";
        }
        $('reload').style.backgroundImage = 'url("images/loading.gif")';
        var xhr = new XMLHttpRequest();
            xhr.open('POST', 'http://twitter.com/statuses/' + type +'.json', true);
            xhr.setRequestHeader('Authorization','Basic ' + base64encode(this.user + ':' + this.pass));
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.setRequestHeader('User-Agent', 'Twippera ('+this.version+')');
            self.XHRID = setTimeout(function(){ 
                if(xhr.readyState == 0 || xhr.readyState == 4) return;
                xhr.abort();
                self.showPopup(
                    SPLangs.timeout[self.locale],
                    SPLangs.close[self.locale],
                    function() {}
                );
                $('reload').style.backgroundImage = 'url("images/reload.gif")';
                clearTimeout(self.XHRID);
            }, this.timeout);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200){
                    clearTimeout(self.XHRID);
                    if(type == 'friends_timeline') {
                        self.updateCache(xhr.responseText);
                    } else if(type == 'update') {
                        if(self.postMsgs[0]) {
                            if(!self.postMsgs[0].post) {
                                self.postMsgs.shift();
                            }
                        }
                        self.postMsgs.unshift({msg: status, post: 1});
                        self.postMsgs.unshift({msg: "", post : 0});
                        self.PMindx = 0;
                        self.updateCache('[' + xhr.responseText + ']');
                    }
                    $('reload').style.backgroundImage = 'url("images/reload.gif")';
                    self.watchKeyEvent("");
                }
            }
            xhr.send('status=' + status.replace(/(&|\+|\*|;)/g,
                function($0, $1) {
                    return encodeURIComponent($1);
                }
            ));
    },
    updateCache : function(txt) {
        eval('var json=(' + txt + ')');
        // [{"id":,"created_at":,"text":,"user":{"name":,"profile_image_url":,"description":,"location":,"url":,"id":,"protected":,"screen_name":}},.....]
        var tmp = []
        for(var i=0, len=json.length; i<len; i++) {
            if(this.cache.length == 0 || this.checkCache(json[i]['id'])) {
                // キャッシュになければ追加
                tmp.push({
                    id     : json[i]['id'],
                    img    : json[i]['user']['profile_image_url'],
                    usr    : json[i]['user']['screen_name'],
                    msg    : json[i]['text'],
                    time   : json[i]['created_at'],
                    cached : 0
                });

            }
        }
        if(this.cache.length ==0) {
            this.cache = tmp;
        } else {
            this.cache = tmp.concat(this.cache);
        }
        this.sortCache();
        this.parseJSON2HTML();
    },
    // id 順にソート
    // 他のソートアルゴリズム実装も考える
    sortCache : function() {
        var list = this.cache
        var end = list.length - 1;
        for(var i=0;i<end;i++) {
            for(j=i+1;j<=end;j++){
                if(list[i]['id'] < list[j]['id']) {
                    var tmp = list[i];
                    list[i] = list[j];
                    list[j] = tmp
                }
            }
        }
        return list;
    },
    checkCache : function(id) {
        var c = true;
        for(var i=0,len=this.cache.length;i<len;i++) {
            if(this.cache[i]['id'] == id) {
                c = false;
                break;
            }
        }
        return c;
    },
    parseJSON2HTML : function() {
        var list = [];
        for(var i=0, len=this.cache.length; i<len; i++) {
            var usr = this.cache[i];
            var li  = document.createElement('li');
            var img = document.createElement('img');
                img.src = usr['img'];
                img.setAttribute('alt', usr['usr']);
                img.style.width = '16px';
                img.style.height = '16px';
                img.setAttribute('onclick', "Twippera.replyUser('" + usr['usr'] + "')");
            var span = document.createElement('span');
                span.setAttribute('class', 'user');
                span.appendChild(document.createTextNode(usr['usr']));
                li.appendChild(document.createTextNode(' '));
                li.appendChild(img);
                li.appendChild(span);
                li.appendChild(document.createTextNode(' : '));
            var msg = document.createElement('span');
            if(usr['msg'].indexOf('@' + this.user) == 0) {
                msg.className = 'tome';
            }
            if(usr.cached) {
                msg.innerHTML = usr['msg'];
            } else {
                var tmpMsg = this.createHTML(usr['msg']);
                msg.innerHTML = tmpMsg;
                this.cache[i]['msg'] = tmpMsg;
                this.cache[i]['cached'] = 1;
            }
                li.appendChild(msg);
            var time = document.createElement('span');
                time.setAttribute('class', 'post_time');
                time.innerHTML = this.createTime(this.cache[i]['time']);
                li.appendChild(time);
            if(i%2 != 0) {
                var st
                li.setAttribute('class', "zebra");
            }
            list.push(li.outerHTML);
        }
        $('updateList').innerHTML = list.join('');
    },
    createTime : function(time) {
        var t = time.split(' ');
        var Month = {
            'Jan' : 0,
            'Feb' : 1,
            'Mar' : 2,
            'Apr' : 3,
            'May' : 4,
            'Jun' : 5,
            'Jul' : 6,
            'Aug' : 7,
            'Sep' : 8,
            'Oct' : 9,
            'Nov' : 10,
            'Dec' : 11
        };
        var y = parseInt(t[5]);
        var m = Month[t[1]];
        var d = parseInt(t[2]);
        var time = t[3].split(':')
        var H = parseInt(time[0]);
        var M = parseInt(time[1]);
        var S = parseInt(time[2]);
        var postTime = Date.UTC(y, m, d, H, M, S);
        var nowTime = new Date().getTime();
        var sa = Math.round((nowTime - postTime) / 60 / 1000);
        if(sa < 1) {
            return SPLangs['less'][this.locale];
        } else if(sa == 1) {
            return sa + SPLangs['minago'][this.locale]
        } else if(sa > 1 && sa < 60) {
            return sa + SPLangs['minsago'][this.locale]
        } else {
            var hours = Math.floor(sa / 60);
            return (hours == 1) ? hours + SPLangs['hrago'][this.locale] : hours + SPLangs['hrsago'][this.locale];
        }
    },
    createHTML : function(text) {
        var self = this;
        var div  = document.createElement('div');
        var text = document.createTextNode(text);
        div.appendChild(text);

        return div.innerHTML.replace(
            /(https?|ftp)(:\/\/[-_.!~*\'a-zA-Z0-9;\/?:\@&=+\$,%#]+)/g,
            function($0, $1){
                var url = $0;
                if(url.indexOf('http://tinyurl.com/') == 0 || url.indexOf('http://z.la/') == 0) {
                    url = DecodeURI(self.resolveTinyUrl($0));
                }
                url = encodeURI(url);
                return '<a href="' + url + '">' + url +'</a>'
            }
        );
    },
    // Tinyurl 展開: 1つに付き about 600ms
    resolveTinyUrl : function(url) {
        var exURL;
        var xhr = new XMLHttpRequest();
            xhr.open('HEAD', url, false);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4) {
                    exURL = xhr.getResponseHeader('Location');
                }
            }
            xhr.send(null);
        return exURL
    },
    // @付き返信
    replyUser : function(user) {
        var status   = $('status');
        var msg = status.value;
        status.value = '@' + user + ' ' + msg;
        setCaretPosition(status, status.value.length);
    },
    // アップデートチェック
    checkUpdate : function() {
        var self = this;
        var url = 'http://opera.higeorange.com/misc/twippera/twipperaRelease.txt'
        var xhr = new XMLHttpRequest();
            xhr.open('GET', url);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200) {
                    var t = xhr.responseText.split(':')
                    var release = parseInt(t[0]);
                    var ver = t[1];
                    if(self.release < release) {
                        self.showPopup(
                            SPLangs.update[self.locale] + ' : ' + ver,
                            SPLangs.download[self.locale],
                            function() {
                                widget.openURL('http://widgets.opera.com/widget/6522');
                            }
                        );
                    }
                }
            }
            xhr.send(null);
    },
    // ポップアップ処理
    // 引数: メッセージ, ボタンテキスト, ボタンクリック関数
    showPopup: function(txt, btntxt, func) {
        var self = this;
        var popup = $('popup');
            popup.style.display = 'block';
        var ppmsg = popup.getElementsByTagName('p')[0];
            ppmsg.innerHTML = txt;
        var btn = document.evaluate(
            './div/div/div/div/p/button',
            popup,
            null,
            XPathResult.FIRST_ORDERED_NODE_TYPE,
            null
        ).singleNodeValue;
            btn.addEventListener(
                'click',
                function(){
                    self.hidePopup();
                    func();
                },
                false
            );
        var btnInner = document.evaluate(
            './span/span',
            btn,
            null,
            XPathResult.FIRST_ORDERED_NODE_TYPE,
            null
        ).singleNodeValue;
            btnInner.innerHTML = btntxt;
    },
    hidePopup: function() {
        var popup = $('popup');
            popup.style.display = 'none';
    }
};

window.addEventListener('load', function() {
    Twippera.loadSetting();
    Twippera.checkUpdate();
    Twippera.initEvent();
},false);
